PlaceEnemy:
; Places an enemy ship based on the "random" number in the variable board_counter
; Variables: enemy_board, ship_length, ship_type, board_counter
; Affects: a, hl, bc, de
    ld hl, enemy_board    ;Start of the enemy board
    ld a,(ship_length)
    ld b, a
    ld a,(board_counter)
    ld c, a
    ld a,(rotated)        ;Decide whether the ship shall be rotated
    xor c
    bit 0, a
    jr nz,EnemyRotated


    ;If the ship was not rotated:

    ;Make sure, that the ship is within the board
    ld a, c               ;Load board_counter
    and %00000111         ;Mask out numbers higher than 7
    add a, b              ;Add the ships length
    sub 8                 ;Subtract 8...
    jp m,+
    ld d, a               ;...and if the result was positive:
    ld a, c               ;Subtract the result from board_counter
    sub d
    ld c, a
+:  ld b, 0
    add hl, bc            ;Enemy location on the board

    ;Make sure, that no other ships are at that position
    ld d, h
    ld e, l
    ld a,(ship_length)
    ld b, a
-:  ld a, (de)            ;Look for a ship "ship_length" to the right...
    bit 6, a
    jr z,+
    call CountBoard       ;...and if one is found, jump one tile
    jr PlaceEnemy         ;and start all over
+:  inc de
    djnz -

    ;Place the ship on the enemy board
    ld a,(ship_length)
    ld b, a
    ld a,(ship_type)
-:  ld (hl), a
    inc hl
    djnz -
    ret

    ;If the ship was rotated:

EnemyRotated:
    ;Make sure, that the ship is within the board
    ld d, 0
    ld a, c               ;Load board_counter
    and %11111000         ;Mask out numbers lower than 7
    jr z,++               ;Skip the whole thing if it's zero
-:  inc d
    sub 8                 ;Divide by 8
    jr nz,-
    ld a, d
    add a, b              ;Add the ships length
    sub 8                 ;Subtract 8...
    jp m,+
    ld d, a               ;...and if the result was positive:
    ld b, 8
    ld a, c
-:  sub d                 ;Subtract 8 * the result from board_counter
    djnz -
    ld c, a
++:
+:  ld b, 0
    add hl, bc            ;Enemy location on the board
    
    ;Make sure, that no other ships are at that position
    ld d, h
    ld e, l
    push de
         ld a,(ship_length)
         ld b, a
         ld de, 8
-:       ld a, (hl)            ;Look for a ship "ship_length" down
         bit 6, a
         jr z,+
         pop de
         call CountBoard       ;...and if one is found, jump one tile
         jp PlaceEnemy         ;and start all over
+:       add hl, de
         djnz -
    pop de
    ex de, hl

    ;Place the ship on the enemy board
    ld a,(ship_length)
    ld b, a
    ld a,(ship_type)
    ld de, 8
-:  ld (hl), a            ;Place the ship on the enemy board
    add hl, de
    djnz -
    ret